//+------------------------------------------------------------------+
//|                                                    4H_expert.mq4 |
//|                                           jojolalpin@hotmail.com |
//+------------------------------------------------------------------+

extern string  EAname = "4H_expert";
extern int     Magic = 1234567;
extern double  Lots = 1.0;
extern int     StopLoss = 30;
extern int     TakeProfit = 80;
extern int     TrailingStop = 30;
extern int     MaxTradesPerPair = 1;
extern int     UseMM = 0;
extern double  Risk = 10;
extern int     Trade_Delay = 300;

int     slippage = 5;
int     delta = 5;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double lotsi = 0;
   int cnt = 0;
   int CurrentTrades = 0;
   double a1=0, b1=0, askb=0, bids=0;

   
   //Checks for Bar Length enougth length
   if( MathAbs(High[1]-Low[1]) < (Ask-Bid)+ 4*delta*Point ) return(0);

   //Checks for Last Trade Time greatre than Trade_Delay seconds
   if(CurTime() - LastTradeTime() < Trade_Delay) return(0);
   
   //Checks for TrailingStop Value
   if(TrailingStop<5) { Print("Invalid trailing stop"); return(0); }

   a1=Ask+delta*Point;
   b1=Bid-delta*Point;
   askb=Ask+delta*Point;
   bids=Bid-delta*Point;


   //MONEY MANAGEMENT
   if(UseMM!=0)
   {
      lotsi=MathCeil(AccountBalance()*Risk/10000)/10;
      if(lotsi>1) lotsi=MathCeil(lotsi);
      if(lotsi>100) lotsi=100;
   }
   else lotsi=Lots;

   //COMPUTES EA's ORDERS COUNT
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && OrderComment()== EAname)
         CurrentTrades++;
   }

// ====================================================================================================
// TRADE ENTRY
// ====================================================================================================

   if( CurrentTrades < MaxTradesPerPair )
   {
      if(b1<Low[1])  { OrderSend(Symbol(),OP_SELLSTOP,lotsi,bids,slippage,bids+StopLoss*Point,bids-TakeProfit*Point,EAname,Magic,0,Gold); return(0);}
      if(a1>High[1]) { OrderSend(Symbol(),OP_BUYSTOP,lotsi,askb,slippage,askb-StopLoss*Point,askb+TakeProfit*Point,EAname,Magic,0,White); return(0);}
   }
   
// ====================================================================================================
// CHECKS FOR CLOSE
// ====================================================================================================
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && OrderComment()== EAname)
      {
         if(b1<Low[1])
         {
            if(OrderType()==OP_BUY)
               OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
            if(OrderType()==OP_BUYSTOP)
               OrderDelete(OrderTicket());
         }
         if(a1>High[1])
         {
            if(OrderType()==OP_SELL)
               OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Gold);
            if(OrderType()==OP_SELLSTOP)
               OrderDelete(OrderTicket());
         }
      }
   }
   
// ====================================================================================================
// CHECKS FOR TRAILING STOPS
// ====================================================================================================
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && OrderComment()== EAname)
      {
         if(OrderType()==OP_BUY  && ( OrderStopLoss() < Bid - TrailingStop*Point  || OrderStopLoss()==0 ) )
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid - TrailingStop*Point,OrderTakeProfit(),0,White);
         
         if(OrderType()==OP_SELL && ( OrderStopLoss() > Ask + TrailingStop*Point  || OrderStopLoss()==0 ) )
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask + TrailingStop*Point,OrderTakeProfit(),0,White);
      }
   }
    
//----
   return(0);
  }
//+------------------------------------------------------------------+

int LastTradeTime()
{
   //Look for a trade in opened orders
   int i, tot = OrdersTotal();
   for(i=tot;i>0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if( OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && OrderComment()== EAname)
         return(OrderOpenTime());
   }
   
   //Look for a trade in orders history
   tot = HistoryTotal();
   for(i=tot;i>0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if( OrderMagicNumber() == Magic && OrderSymbol()==Symbol() && OrderComment()== EAname)
         return(OrderOpenTime());
   }
   return(0);
}